


service Echo {

  P2PMessageRequest echo(1: P2PMessageRequest message)
}


struct P2PMessageRequest{
	1: WebrtcMessageHeader header
	2:  WebrtcMessagePayload payload

}

struct WebrtcMessageHeader{
	1: optional i32 protocolVersion
	2: optional i64 messageId
	3: optional i64 callId
	4: optional i64 sender
	5: optional i64 receiver
	6: optional i64 capabilities
	7: optional i32  payloadType
	8: byte retryCount
	9: bool pranswerSupported 
10: optional i32 ackMessageType
11: optional WebrtcMessageEndpoint source
12: optional WebrtcMessageEndpoint destination
	13: optional string rtcHandle
	14: optional i32 clientStack
	15: optional i64 serverMsgTime
}

struct WebrtcMessageEndpoint{
	1:  string deviceId
	2:  i64 appId
}


struct WebrtcMessagePayload{
	1: optional OfferPayload offerPayload
	3: optional AnswerPayload answerPayload
	18: optional SdpUpdatePayload sdpUpdatePayload
}

struct OfferPayload{
	1: optional Sdp sdpThrift
	2: i32 uploadLogLevel
	5: string offeredFbExperiments
	8: optional VideoRequestPayload videoRequestPayload
	10: optional NotifyMediaStatePayload initialMediaState
	11: string callType
	14: optional bool offerEscalationSupport
	15: optional string escalationConferenceName
	16: optional string sdpString
	17: optional string userCapabilities
	18: optional string callTrigger
	19: optional bool sdpNegotiationSupport
	20: optional list<GenericDataMessage> extraParams 
	21: optional map<string, StreamInfo> streamInfos_DEPRECATED 
	22: optional string collisionContext
	23: optional map<string, TrackInfo> trackInfos


}

struct Sdp{
	1:  optional SessionDescription sessionDescription
	2: optional list<MediaDescription> mediaDescriptions
} 

struct SessionDescription{
	1: optional string sessionId
	2: optional string sessionVersion
	3: bool supportsMsid
	4: optional bool useIceLite //not sure about this one
	5: optional list<string> features //not sure of type
	6: optional i32 connectionRole
	7: optional Bandwidth bandwidth
	8: optional list<string> transportBundle
	9: optional list<CryptoParam> commonCryptos 
}

struct Bandwidth{
	1: string bwtype
	2: i32 bw
}

struct CryptoParam{
	1: optional i32 tag
	2: optional i32 suite
	3: optional string keyParams
}


struct MediaDescription{
	1: optional i32 mediaType
	2: i32 port
	3: i32 protocol
	4: optional string mediaIceUserFrag
5: optional string mediaIcePassword
6: optional list<string> mediaIceOptions
7: optional string mediaSslFingerprintHash
8: optional string mediaSslFingerprintDigest
9: optional list<Extmap> extmaps 
10: optional i32 sendRecvMode
11: bool hasRtcpMux
12: optional list<CryptoParam> cryptoParams
	13: optional list <CodecDescription> codecs
	14: optional i32 maxPTime
	15: optional i32 pTime
	16: optional list<SsrcObject> ssrcObjects
	17: optional list<IceCandidateSdp> candidates
	18: optional bool conferenceMode
	19: optional list<SsrcGroup> ssrcGroups
	20: optional i32 connectionRole
	21: optional string mid	
	22: optional string fmt
	23: optional Bandwidth bandwidth
	24: optional i32 sctpPort
	25: optional bool rtcpReducedSize
}

struct Extmap{
	1: i32 id
	2: optional i32 uri
}



struct CodecDescription{
	1: optional byte payloadType 
	2: optional i32 encodingName
	3: optional byte clockRateKhz
	4: byte numAudioChannels
	5: optional map<i32, string> fmtParameters
	6: optional set<i32> enabledOptions
	7: optional map<string, string> rtcpFbParameters
	8: optional i32 videoWidth
	9: optional i32 videoHeight
	10: optional list<RtcpFbVal> rtcpFbParamList
}


struct RtcpFbVal{
	1: string id
	2: optional string param
	 
}

struct SsrcObject{
	1: optional i32 ssrcId
	2: optional string cname
	3: optional string msid
	4: optional string msidAppData
} 

struct IceCandidateSdp{
	1: optional string foundation
	2: byte componentId
	3: i32 transport
	4: optional i32 priority
	5: optional string address
	6: optional i32 port
	7: optional i32 protocolType
	8: optional string relatedAddress
	9: optional i32 relatedPort
	10: optional string username
	11: optional string passwordgener
	12: i32 generation
	13: optional i32 tcptype
	14: optional i16 networkId
	15: optional i32 networkCost
	
}


struct SsrcGroup{
	1: optional string semantics
	2: optional list<i32> ssrcIds
}

struct VideoRequestPayload{
	1: optional bool islocalVideoOn
	2: optional bool requestRemoteVideoOn
	3: optional i16 ackMessageId

}

struct NotifyMediaStatePayload{
	1: bool videoOn
	2: bool audioOn
	3: bool speakerOn
	9: optional map<string, TrackInfo> trackInfos
	10: optional i32 version
}

struct TrackInfo{
	1: optional i32 label
	2: optional bool enabled

}

struct GenericDataMessage{
	1: string basic
	2: string data
	3: string e2eEncryptedData

}

struct StreamInfo{
	1: optional string type
}


struct SdpUpdatePayload{
	1: optional Sdp sdpThrift
	2: optional i64 ackMessageId
	3: optional string SdpString
	4: optional map<string, StreamInfo> streamInfos_DEPRECATED
	5: optional map<string, TrackInfo> trackInfos

}


struct AnswerPayload {
	1: optional Sdp sdpThrift
	4: optional VideoRequestPayload videoRequestPayload
	6: string selectedFbExperiments
	7: optional NotifyMediaStatePayload initialMediaState
	8: string callType
	9: optional bool negotiatedEscalationSupport
	12: optional string escalationConferenceName
	13: optional string sdpString
	14: optional string userCapabilities
	15: optional bool sdpNegotiationSupport
	16: optional map<string, StreamInfo> streamInfos_DEPRECATED
	18: optional string collisionContext
	19: optional map<string, TrackInfo> trackInfos	
}
